Attribute VB_Name = "CardProc"
Option Explicit

Private iLast As Long
Private Const A As Long = 48271
Private Const M As Long = 2147483647
Private Const q As Long = (M / A)
Private Const R As Long = (M Mod A)
Private Const rT As Single = 1# / M

Public Enum EErrorRandom
    eeBaseRandom = 13580    ' Random
End Enum

Public Sub ShuffleArray(ar() As Byte)
'  
Dim iFirst As Long, iLast As Long, i As Long, v As Variant, iRnd As Long
Dim q

iFirst = LBound(ar)
iLast = UBound(ar)

For i = iLast To iFirst + 1 Step -1

    iRnd = Random(iFirst, i)
    
    'swap
    q = ar(i)
    ar(i) = ar(iRnd)
    ar(iRnd) = q

Next i

End Sub
Private Function Random(Optional ByVal iMin As Long = 0, _
                Optional ByVal iMax As Long = M) As Long
    Dim iLo As Long, iHi As Long, iT As Long
    
    iLast = Abs(timeGetTime)
    
    iHi = iLast / q
    iLo = iLast Mod q
  
    iT = A * iLo - R * iHi
    If iT > 0 Then
        iLast = iT
    Else
        iLast = iT + M
    End If
    Random = iLast
    If iMin <> 0 Or iMax <> M Then
        If iMin < iMax Then
            Random = iMin + (iLast Mod (iMax - iMin + 1))
        Else
            Random = iMax + (iLast Mod (iMin - iMax + 1))
        End If
    End If

End Function


