Attribute VB_Name = "CardProc"
Option Explicit

Dim iLast As Long
Dim A As Long
Dim M As Long
Dim q As Long
Dim R As Long
Dim rT As Single

Public Enum EErrorRandom
    eeBaseRandom = 13580    ' Random
End Enum
Function CompareCards(Frst As ECardFace, Scnd As ECardFace) As Integer
'     ,  1 -    
' ,  -1 -      ,
'  0 -   

'     
If Scnd = ecfAce Then
    If Frst = ecfKing Then
        CompareCards = -1
        Exit Function
    ElseIf Frst = ecfTwo Then
        CompareCards = 1
        Exit Function
    Else
        CompareCards = 0
        Exit Function
    End If
'  
ElseIf Frst = ecfKing Then
    If Scnd = ecfAce Then
        CompareCards = 1
        Exit Function
    ElseIf Scnd = ecfQueen Then
        CompareCards = -1
        Exit Function
    Else
        CompareCards = 0
        Exit Function
    End If
'   
Else
    If Frst = Scnd + 4 Then
        CompareCards = 1
        Exit Function
    ElseIf Scnd = Frst + 4 Then
        CompareCards = -1
        Exit Function
    Else
        CompareCards = 0
        Exit Function
    End If
End If

End Function

Public Sub ShuffleArray(ar() As Integer)
'  
Dim iFirst As Long, iLast As Long, i As Long, v As Variant, iRnd As Long
Dim q

iFirst = LBound(ar)
iLast = UBound(ar)

InitRnd

For i = iLast To iFirst + 1 Step -1

    iRnd = Random(iFirst, i)
    
    'swap
    q = ar(i)
    ar(i) = ar(iRnd)
    ar(iRnd) = q

Next i

End Sub
Private Function Random(Optional ByVal iMin As Long = 0, _
                Optional ByVal iMax As Long = 2147483647) As Long
    Dim iLo As Long, iHi As Long, iT As Long
    
    iLast = Rnd(Rnd(GetTickCount) * 255) * 255
    
    iHi = iLast / q
    iLo = iLast Mod q
  
    iT = A * iLo - R * iHi
    If iT > 0 Then
        iLast = iT
    Else
        iLast = iT + M
    End If
    Random = iLast
    If iMin <> 0 Or iMax <> M Then
        If iMin < iMax Then
            Random = iMin + (iLast Mod (iMax - iMin + 1))
        Else
            Random = iMax + (iLast Mod (iMin - iMax + 1))
        End If
    End If

End Function



Private Sub InitRnd()

 A = Rnd(GetTickCount) * 48271
 M = Rnd(GetTickCount) * 2147483647
 q = Rnd(GetTickCount) * (M / A)
 R = Rnd(GetTickCount) * (M Mod A)
 rT = 1# / M


End Sub
