VERSION 5.00
Begin VB.UserControl ActCard 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1365
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   960
   ScaleHeight     =   1365
   ScaleWidth      =   960
   ToolboxBitmap   =   "ActCard.ctx":0000
End
Attribute VB_Name = "ActCard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Dim ectCardType As ECardType '   - ectFaces,
                                                                                            'ectBacks,
Dim ecbCardBack As ECardBack ', X  O

Dim ecsCardSuit As ECardSuit ' - ecsClubs, ecsDiamonds, ecsHearts, ecsSpades

Dim ecfCardFace As ECardFace ' 

Dim longCardWidth As Long, longCardHeight As Long '   

Dim longCardTop As Long, longCardLeft As Long

Const m_def_CardType = 0
Const m_def_CardSuit = 0
Const m_def_CardFace = 0
Const m_def_BCStopped = &H8000&
Const m_def_BCMoveable = &H8000000E
Const m_def_BCEngaged = &H8000000F
Const m_def_CardBack = 53
Const m_def_State = 0
Const m_def_InvertColor = 0
Const m_def_SuitColor = 0

Dim m_CardType As ECardType
Dim m_CardSuit As ECardSuit
Dim m_CardFace As ECardFace
Dim m_BCStopped As OLE_COLOR
Dim m_BCMoveable As OLE_COLOR
Dim m_BCEngaged As OLE_COLOR
Dim m_CardBack As ECardBack
Dim m_State As EState
Dim m_InvertColor As OLE_COLOR
Dim m_SuitColor As OLE_COLOR

'Event HitTest(X As Single, Y As Single, HitResult As Integer) 'MappingInfo=UserControl,UserControl,-1,HitTest
Event Hide() 'MappingInfo=UserControl,UserControl,-1,Hide
Attribute Hide.VB_Description = ",       ."
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp

Public Enum EState ' 
    esMoveable = 0 ',     
    esEngaged = 1 ',      
    esStopped = 2 ',    
    esFree = 3 ',     
End Enum
'Default Property Values:
Const m_def_Row = 0
Const m_def_Col = 0
Const m_def_ZOrd = 0
Const m_def_BCFree = &HFF&
'Property Variables:
Dim m_Row As Integer
Dim m_Col As Integer
Dim m_ZOrd As Integer
Dim m_BCFree As OLE_COLOR




Private Sub UserControl_Initialize()

UserControl.AutoRedraw = True

ScaleMode = vbPixels

'  

  cdtInit longCardWidth, longCardHeight

'msgbox "Initialize" & vbCrLf & ErrNumber

longCardWidth = longCardWidth * Screen.TwipsPerPixelX
longCardHeight = longCardHeight * Screen.TwipsPerPixelY

'MyhDC = GetWindowDC(Me.hWnd)
Refresh ' "Initialize"

End Sub
'
'
'Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
'    RaiseEvent OLEStartDrag(Data, AllowedEffects)
'
'End Sub

Private Sub UserControl_Paint()
Refresh
End Sub


Private Sub UserControl_Resize()

With UserControl

.Height = longCardHeight + 30

.Width = longCardWidth + 30

RaiseEvent Resize

Refresh

End With

End Sub

'Private Sub UserControl_Show()
'
''Me.ScaleHeight = longCardHeight
''
''Me.ScaleWidth = longCardWidth
''
''cdtDraw MyhDC, longCardLeft, longCardTop, ecsCardSuit, ectCardType, longCardColor
'
''Refresh'
'
'End Sub
'
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=0,0,0,0
'Public Property Get Enabled() As Boolean
'    Enabled = m_Enabled
'End Property
'
'Public Property Let Enabled(ByVal New_Enabled As Boolean)
'    m_Enabled = New_Enabled
'    PropertyChanged "Enabled"
'End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=7,0,0,0
'Public Property Get MousePointer() As Integer
'    MousePointer = m_MousePointer
'End Property
'
'Public Property Let MousePointer(ByVal New_MousePointer As Integer)
'    m_MousePointer = New_MousePointer
'    PropertyChanged "MousePointer"
'End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=14,0,0,0
'Public Property Get Style() As Variant
'    Style = m_Style
'End Property
'
'Public Property Let Style(ByVal New_Style As Variant)
'    m_Style = New_Style
'    PropertyChanged "Style"
'End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
'    m_Enabled = m_def_Enabled
'    m_MousePointer = m_def_MousePointer
'    m_Style = m_def_Style
'    m_CardType = m_def_CardType
'    m_CardBack = m_def_CardBack
'    m_CardSuit = m_def_CardSuit
'    m_CardFace = m_def_CardFace
    m_SuitColor = m_def_SuitColor
    m_InvertColor = m_def_InvertColor
'    m_Moveable = m_def_Moveable
'    m_Engageable = m_def_Engageable
    m_CardBack = m_def_CardBack
    m_State = m_def_State
    m_BCMoveable = m_def_BCMoveable
    m_BCEngaged = m_def_BCEngaged
    m_BCStopped = m_def_BCStopped
    m_CardType = m_def_CardType
    m_CardSuit = m_def_CardSuit
    m_CardFace = m_def_CardFace
    m_BCFree = m_def_BCFree
    m_Row = m_def_Row
    m_Col = m_def_Col
    m_ZOrd = m_def_ZOrd
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

'    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
'    m_MousePointer = PropBag.ReadProperty("MousePointer", m_def_MousePointer)
'    m_Style = PropBag.ReadProperty("Style", m_def_Style)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
'    m_CardType = PropBag.ReadProperty("CardType", m_def_CardType)
'    m_CardBack = PropBag.ReadProperty("CardBack", m_def_CardBack)
'    m_CardSuit = PropBag.ReadProperty("CardSuit", m_def_CardSuit)
'    m_CardFace = PropBag.ReadProperty("CardFace", m_def_CardFace)
    UserControl.ScaleHeight = PropBag.ReadProperty("ScaleHeight", 3600)
    UserControl.ScaleLeft = PropBag.ReadProperty("ScaleLeft", 0)
    UserControl.ScaleTop = PropBag.ReadProperty("ScaleTop", 0)
    UserControl.ScaleWidth = PropBag.ReadProperty("ScaleWidth", 4800)
    m_SuitColor = PropBag.ReadProperty("SuitColor", m_def_SuitColor)
    m_InvertColor = PropBag.ReadProperty("InvertColor", m_def_InvertColor)
'    UserControl.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
'    m_Moveable = PropBag.ReadProperty("Moveable", m_def_Moveable)
'    m_Engageable = PropBag.ReadProperty("Engageable", m_def_Engageable)
    m_CardBack = PropBag.ReadProperty("CardBack", m_def_CardBack)
    m_State = PropBag.ReadProperty("State", m_def_State)
    m_BCMoveable = PropBag.ReadProperty("BCMoveable", m_def_BCMoveable)
    m_BCEngaged = PropBag.ReadProperty("BCEngaged", m_def_BCEngaged)
    m_BCStopped = PropBag.ReadProperty("BCStopped", m_def_BCStopped)
'    UserControl.HitBehavior = PropBag.ReadProperty("HitBehavior", 1)
    m_CardType = PropBag.ReadProperty("CardType", m_def_CardType)
    m_CardSuit = PropBag.ReadProperty("CardSuit", m_def_CardSuit)
    m_CardFace = PropBag.ReadProperty("CardFace", m_def_CardFace)
    m_BCFree = PropBag.ReadProperty("BCFree", m_def_BCFree)
    m_Row = PropBag.ReadProperty("Row", m_def_Row)
    m_Col = PropBag.ReadProperty("Col", m_def_Col)
    m_ZOrd = PropBag.ReadProperty("ZOrd", m_def_ZOrd)
End Sub


Private Sub UserControl_Show()
Refresh ' "Show"
End Sub

'Private Sub UserControl_Show()
'Refresh' "Show"
'End Sub

Private Sub UserControl_Terminate()
'c  
  cdtTerm

'msgbox "Terminate" & vbCrLf & ErrNumber
'Call ReleaseDC(Me.hWnd, MyhDC)

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

'    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
'    Call PropBag.WriteProperty("MousePointer", m_MousePointer, m_def_MousePointer)
'    Call PropBag.WriteProperty("Style", m_Style, m_def_Style)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
'    Call PropBag.WriteProperty("CardType", m_CardType, m_def_CardType)
'    Call PropBag.WriteProperty("CardBack", m_CardBack, m_def_CardBack)
'    Call PropBag.WriteProperty("CardSuit", m_CardSuit, m_def_CardSuit)
'    Call PropBag.WriteProperty("CardFace", m_CardFace, m_def_CardFace)
    Call PropBag.WriteProperty("ScaleHeight", UserControl.ScaleHeight, 3600)
    Call PropBag.WriteProperty("ScaleLeft", UserControl.ScaleLeft, 0)
    Call PropBag.WriteProperty("ScaleTop", UserControl.ScaleTop, 0)
    Call PropBag.WriteProperty("ScaleWidth", UserControl.ScaleWidth, 4800)
    Call PropBag.WriteProperty("SuitColor", m_SuitColor, m_def_SuitColor)
    Call PropBag.WriteProperty("InvertColor", m_InvertColor, m_def_InvertColor)
'    Call PropBag.WriteProperty("OLEDropMode", UserControl.OLEDropMode, 0)
'    Call PropBag.WriteProperty("Moveable", m_Moveable, m_def_Moveable)
'    Call PropBag.WriteProperty("Engageable", m_Engageable, m_def_Engageable)
    Call PropBag.WriteProperty("CardBack", m_CardBack, m_def_CardBack)
    Call PropBag.WriteProperty("State", m_State, m_def_State)
    Call PropBag.WriteProperty("BCMoveable", m_BCMoveable, m_def_BCMoveable)
    Call PropBag.WriteProperty("BCEngaged", m_BCEngaged, m_def_BCEngaged)
    Call PropBag.WriteProperty("BCStopped", m_BCStopped, m_def_BCStopped)
'    Call PropBag.WriteProperty("HitBehavior", UserControl.HitBehavior, 1)
    Call PropBag.WriteProperty("CardType", m_CardType, m_def_CardType)
    Call PropBag.WriteProperty("CardSuit", m_CardSuit, m_def_CardSuit)
    Call PropBag.WriteProperty("CardFace", m_CardFace, m_def_CardFace)
    Call PropBag.WriteProperty("BCFree", m_BCFree, m_def_BCFree)
    Call PropBag.WriteProperty("Row", m_Row, m_def_Row)
    Call PropBag.WriteProperty("Col", m_Col, m_def_Col)
    Call PropBag.WriteProperty("ZOrd", m_ZOrd, m_def_ZOrd)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
    Refresh ' "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
    Refresh ' "MousePointer"
End Property
Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
'    Refresh
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    Refresh
End Sub
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=14,0,0,0
'Public Property Get CardType() As ECardType
'    CardType = m_CardType
'End Property
'
'Public Property Let CardType(ByVal New_CardType As ECardType)
'    m_CardType = New_CardType
'    PropertyChanged "CardType"
'    Refresh ' "CardType"
'End Property
''
'''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'''MemberInfo=14,0,0,0
''Public Property Get CardBack() As ECardBack
''    CardBack = m_CardBack
''End Property
''
''Public Property Let CardBack(ByVal New_CardBack As ECardBack)
''    m_CardBack = New_CardBack
''    PropertyChanged "CardBack"
''    Refresh ' "CardBack"
''End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=14,0,0,0
'Public Property Get CardSuit() As ECardSuit
'    CardSuit = m_CardSuit
'End Property
'
'Public Property Let CardSuit(ByVal New_CardSuit As ECardSuit)
'    m_CardSuit = New_CardSuit
'    PropertyChanged "CardSuit"
'    Refresh ' "CardSuit"
'End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=14,0,0,0
'Public Property Get CardFace() As ECardFace
'    CardFace = m_CardFace
'End Property
'
'Public Property Let CardFace(ByVal New_CardFace As ECardFace)
'    m_CardFace = New_CardFace
'    PropertyChanged "CardFace"
'    Refresh ' "CardFace"
'End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleHeight
Public Property Get ScaleHeight() As Single
    ScaleHeight = UserControl.ScaleHeight
End Property

Public Property Let ScaleHeight(ByVal New_ScaleHeight As Single)
    UserControl.ScaleHeight() = New_ScaleHeight
    PropertyChanged "ScaleHeight"
    Refresh ' "ScaleHeight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleLeft
Public Property Get ScaleLeft() As Single
    ScaleLeft = UserControl.ScaleLeft
End Property

Public Property Let ScaleLeft(ByVal New_ScaleLeft As Single)
    UserControl.ScaleLeft() = New_ScaleLeft
    PropertyChanged "ScaleLeft"
    Refresh ' "ScaleLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleTop
Public Property Get ScaleTop() As Single
    ScaleTop = UserControl.ScaleTop
End Property

Public Property Let ScaleTop(ByVal New_ScaleTop As Single)
    UserControl.ScaleTop() = New_ScaleTop
    PropertyChanged "ScaleTop"
    Refresh ' "ScaleTop"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ScaleWidth
Public Property Get ScaleWidth() As Single
    ScaleWidth = UserControl.ScaleWidth
End Property

Public Property Let ScaleWidth(ByVal New_ScaleWidth As Single)
    UserControl.ScaleWidth() = New_ScaleWidth
    PropertyChanged "ScaleWidth"
    Refresh ' "ScaleWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hDC
Public Property Get MyhDC() As Long
    MyhDC = UserControl.hDC
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh'
Private Sub Refresh()

UserControl.Cls

If m_CardType = ectBacks Then
  cdtDraw MyhDC, ScaleLeft + 15 / Screen.TwipsPerPixelX, ScaleTop + 15 / Screen.TwipsPerPixelY, m_CardBack, m_CardType, m_SuitColor
Else
  cdtDraw MyhDC, ScaleLeft + 15 / Screen.TwipsPerPixelX, ScaleTop + 15 / Screen.TwipsPerPixelY, m_CardSuit + m_CardFace, m_CardType, _
                                                                                                    &HFFFFFFFF - m_InvertColor
End If

End Sub


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get SuitColor() As OLE_COLOR
Attribute SuitColor.VB_Description = " -,    "
    SuitColor = m_SuitColor
End Property

Public Property Let SuitColor(ByVal New_SuitColor As OLE_COLOR)
    m_SuitColor = New_SuitColor
    PropertyChanged "SuitColor"
    Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get InvertColor() As OLE_COLOR
Attribute InvertColor.VB_Description = "  "
    InvertColor = m_InvertColor
End Property

Public Property Let InvertColor(ByVal New_InvertColor As OLE_COLOR)
    m_InvertColor = New_InvertColor
    PropertyChanged "InvertColor"
    Refresh
End Property

Private Sub UserControl_Hide()
    RaiseEvent Hide
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hwnd() As Long
Attribute hwnd.VB_Description = "   ( Microsoft Windows)   ."
    hwnd = UserControl.hwnd
End Property
''
'''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'''MappingInfo=UserControl,UserControl,-1,OLEDrag
''Public Sub OLEDrag()
''    UserControl.OLEDrag
''End Sub
'''
'''Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
'''    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
'''End Sub
'''
'''Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
'''    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
'''End Sub
''''
'''''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'''''MappingInfo=UserControl,UserControl,-1,OLEDropMode
''''Public Property Get OLEDropMode() As Integer
''''    OLEDropMode = UserControl.OLEDropMode
''''End Property
''''
''''Public Property Let OLEDropMode(ByVal New_OLEDropMode As Integer)
''''    UserControl.OLEDropMode() = New_OLEDropMode
''''    PropertyChanged "OLEDropMode"
''''End Property
''
''Private Sub UserControl_OLECompleteDrag(Effect As Long)
''    RaiseEvent OLECompleteDrag(Effect)
''End Sub
''
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=0,0,0,0
'Public Property Get Moveable() As Boolean
'    Moveable = m_Moveable
'End Property
'
'Public Property Let Moveable(ByVal New_Moveable As Boolean)
'    m_Moveable = New_Moveable
'    PropertyChanged "Moveable"
'End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MemberInfo=0,0,0,false
'Public Property Get Engageable() As Boolean
'    Engageable = m_Engageable
'End Property
'
'Public Property Let Engageable(ByVal New_Engageable As Boolean)
'    m_Engageable = New_Engageable
'    PropertyChanged "Engageable"
'End Property
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get CardBack() As ECardBack
    CardBack = m_CardBack
End Property

Public Property Let CardBack(ByVal New_CardBack As ECardBack)
    m_CardBack = New_CardBack
    PropertyChanged "CardBack"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get State() As EState
    State = m_State
End Property

Public Property Let State(ByVal New_State As EState)
    m_State = New_State
    If m_State = esMoveable Then
        UserControl.BackColor = m_BCMoveable
    ElseIf m_State = esEngaged Then
        UserControl.BackColor = m_BCEngaged
    ElseIf m_State = esStopped Then
        UserControl.BackColor = m_BCStopped
    ElseIf m_State = esFree Then
        UserControl.BackColor = m_BCFree
    End If
    PropertyChanged "State"
    Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BCMoveable() As OLE_COLOR
    BCMoveable = m_BCMoveable
End Property

Public Property Let BCMoveable(ByVal New_BCMoveable As OLE_COLOR)
    m_BCMoveable = New_BCMoveable
    PropertyChanged "BCMoveable"
    Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BCEngaged() As OLE_COLOR
    BCEngaged = m_BCEngaged
End Property

Public Property Let BCEngaged(ByVal New_BCEngaged As OLE_COLOR)
    m_BCEngaged = New_BCEngaged
    PropertyChanged "BCEngaged"
    Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BCStopped() As OLE_COLOR
    BCStopped = m_BCStopped
End Property

Public Property Let BCStopped(ByVal New_BCStopped As OLE_COLOR)
    m_BCStopped = New_BCStopped
    PropertyChanged "BCStopped"
    Refresh
End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=UserControl,UserControl,-1,HitBehavior
'Public Property Get HitBehavior() As Integer
'    HitBehavior = UserControl.HitBehavior
'End Property
'
'Public Property Let HitBehavior(ByVal New_HitBehavior As Integer)
'    UserControl.HitBehavior() = New_HitBehavior
'    PropertyChanged "HitBehavior"
'End Property
'
'Private Sub UserControl_HitTest(X As Single, Y As Single, HitResult As Integer)
'    RaiseEvent HitTest(X, Y, HitResult)
'End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=21,0,0,0
Public Property Get CardType() As ECardType
Attribute CardType.VB_Description = "  "
    CardType = m_CardType
End Property

Public Property Let CardType(ByVal New_CardType As ECardType)
    m_CardType = New_CardType
    PropertyChanged "CardType"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=22,0,0,0
Public Property Get CardSuit() As ECardSuit
Attribute CardSuit.VB_Description = " "
    CardSuit = m_CardSuit
End Property

Public Property Let CardSuit(ByVal New_CardSuit As ECardSuit)
    m_CardSuit = New_CardSuit
    PropertyChanged "CardSuit"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=23,0,0,0
Public Property Get CardFace() As ECardFace
Attribute CardFace.VB_Description = " "
    CardFace = m_CardFace
End Property

Public Property Let CardFace(ByVal New_CardFace As ECardFace)
    m_CardFace = New_CardFace
    PropertyChanged "CardFace"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BCFree() As OLE_COLOR
    BCFree = m_BCFree
End Property

Public Property Let BCFree(ByVal New_BCFree As OLE_COLOR)
    m_BCFree = New_BCFree
    PropertyChanged "BCFree"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Row() As Integer
    Row = m_Row
End Property

Public Property Let Row(ByVal New_Row As Integer)
    m_Row = New_Row
    PropertyChanged "Row"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Col() As Integer
    Col = m_Col
End Property

Public Property Let Col(ByVal New_Col As Integer)
    m_Col = New_Col
    PropertyChanged "Col"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get ZOrd() As Integer
    ZOrd = m_ZOrd
End Property

Public Property Let ZOrd(ByVal New_ZOrd As Integer)
    m_ZOrd = New_ZOrd
    PropertyChanged "ZOrd"
End Property

