VERSION 5.00
Object = "{A83961B7-67C0-11D4-A58D-F7D84D30DEDC}#2.0#0"; "ActiveCardLight.ocx"
Begin VB.Form frm 
   BackColor       =   &H00008000&
   Caption         =   "Chez-de-Oevre"
   ClientHeight    =   6690
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6570
   Icon            =   "chez'd'oevre.frx":0000
   LinkTopic       =   "1"
   OLEDropMode     =   1  '
   ScaleHeight     =   446
   ScaleMode       =   3  '
   ScaleWidth      =   438
   StartUpPosition =   3  '  
   WindowState     =   2  '
   Begin ActiveCard.ActCard ActCard 
      Height          =   1470
      Index           =   0
      Left            =   600
      TabIndex        =   0
      Top             =   2640
      Visible         =   0   'False
      Width           =   1095
      _ExtentX        =   1931
      _ExtentY        =   2593
      ScaleHeight     =   98
      ScaleWidth      =   73
      BCFree          =   16776960
   End
   Begin VB.Image imgImage 
      BorderStyle     =   1  ' 
      Height          =   855
      Index           =   0
      Left            =   2280
      Top             =   480
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&"
      Begin VB.Menu mnuNew 
         Caption         =   "& "
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuUndo 
         Caption         =   " &"
         Shortcut        =   ^Z
      End
      Begin VB.Menu mnuSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuParameters 
         Caption         =   "&..."
         Shortcut        =   {F4}
         Visible         =   0   'False
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&"
      Begin VB.Menu mnuGameHelp 
         Caption         =   "&"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "& ..."
         Shortcut        =   +{F1}
      End
   End
End
Attribute VB_Name = "frm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const COUNTCARDS = 51 '    - 1
Private Const POT = COUNTCARDS + 1 '  -  ""
Private Const CARDSHIFT = 200 '   
Private Const CENTER = -1 '    
Private Const CELL_EMPTY = -1 ' ,    (),  ""
Private Const IMAGE_FREE = 1 ',  .  
Private Const IMAGE_ENGAGED = 0 '.  

Private Enum IMAGES
    CENTER_0 = 0 '   
    CENTER_1 = 1
    CENTER_2 = 2
    CENTER_3 = 3
    CENTER_POT = 4 '   
    WING_LEFT_0 = 5
    WING_LEFT_1 = 6
    WING_LEFT_2 = 7
    WING_LEFT_3 = 8
    BOTTOM_LEFT = 9 '    
    WING_RIGHT_0 = 10
    WING_RIGHT_1 = 11
    WING_RIGHT_2 = 12
    WING_RIGHT_3 = 13
    BOTTOM_RIGHT = 14 '     
End Enum

Dim IMA As IMAGES

Dim xX, yY

Dim boolDirection As Boolean ',    ,  
                                                '     ,
                                                'TRUE -    ,
                                                'FALSE -   
Dim boolFirstAce As Boolean ',       

Dim boolExDir As Boolean '     
                                            '   

Dim boolMoving As Boolean ',   

Dim arboolWingEmpty(0 To 9) As Boolean
Dim arboolWingEngaged(0 To 9) As Boolean ' , ,  .
                                                                        ' ,    -    
                                                                        '  -  ,  0  4 - ,
                                                                        ' 5  9 - ,
                                                                        ' 4  9  
                                                                       
Dim boolBottomEmpty As Boolean ',    
                                                                        ' TRUE -   

Dim boolPotEngaged As Boolean ', ,   ,     

Dim intButton As Integer '   ?

Dim intQ As Integer '  
Dim intW As Integer

' 
Dim MedAr(0 To COUNTCARDS) As Integer

'  
Dim CardRow(0 To 4) '  
Dim CardWing(CENTER To 9) '  -  ,  - ,  - 

Private Type StackCell ',   ""
    FirstRow As Integer ',   
    FirstWing As Integer ',   
    FirstZOrd As Integer '   - 0= 
    FirstState As EState '  
    Item As Integer '  
    EndRow As Integer
    EndCol As Integer
    EndZOrd As Integer
    ExplicitFreePot As Boolean ',  TRUE  ,    
                                                '   
    ExplicitDirection As Boolean ',  TRUE ,   
                                    '     ,    
                                    '    ,
                                    ', ,   "   "
End Type
                                                                    
Dim Stack() As StackCell '""

Dim intStackCounter As Integer ' ""

Dim StartRow As Integer, StartWing As Integer, StartZOrd As Integer '        
Dim StartState As EState
'' - ""    
'Dim Grid(0 To 4, CENTER To 9, CELL_EMPTY To 12) As Integer

Private Sub ActCard_MouseDown(Index As Integer, Button As Integer, _
                                                                                    Shift As Integer, X As Single, Y As Single)
With ActCard(Index)
'   "",  - 
If .State = esEngaged Or .State = esStopped Then Exit Sub

'   -
'  
xX = X
yY = Y

' 
boolMoving = True
'  ?
intButton = Button

'  
StartRow = .Row
StartWing = .Col
StartZOrd = .ZOrd
StartState = .State

End With

End Sub

Private Sub ActCard_MouseMove(Index As Integer, Button As Integer, _
                                                                                    Shift As Integer, X As Single, Y As Single)
'  ,  ,       ,
'    - "", 
If boolMoving = True And (ActCard(Index).State = esMoveable Or ActCard(Index).State = esFree) Then
    '   -  
    frm.AutoRedraw = False
    
            With ActCard(Index)
                '  ""  
                .Move .Left + X - xX, .Top + Y - yY
                .ZOrder
            End With
            
    '  
    frm.AutoRedraw = True
    
End If

End Sub

Private Sub ActCard_MouseUp(Index As Integer, Button As Integer, Shift As Integer, _
                                                                                                            X As Single, Y As Single)

Dim boolSuccessMove As Boolean
Dim boolEmptyPack As Boolean
Dim boolFreeBottomRow As Boolean

'     -    ,  
If boolMoving = False Then Exit Sub

' ""  -  
boolMoving = False


''  
boolSuccessMove = PlacedCard(Index, boolFreeBottomRow)
'
''    -   
' ,    
If boolSuccessMove = True Then
    ChangeFreeCard
    boolEmptyPack = CheckEmptyPack
End If
'
'   -    
If boolEmptyPack = True Then
    Greetings
End If

End Sub

Private Sub Form_Click()
'    -       
boolMoving = False

End Sub

Public Sub InitCards()
On Error Resume Next
'  
Dim A

boolExDir = False ' ,     

'________________________________________________________________________________
'    ,  ,    
For intQ = 1 To COUNTCARDS
    '  
    Load ActCard(intQ)
    '   
    ActCard(intQ).Tag = intQ
Next intQ
'________________________________________________________________________________
' -  
Load ActCard(POT)
With ActCard(POT)
    '. .  ,     ,  - .
    .CardType = ectBacks
    ' -   
    .CardBack = ecbO
    '  - ""
    .State = esStopped
    
    .Row = 4
    .Col = CENTER
    .ZOrd = CELL_EMPTY
    .Tag = POT
End With
'________________________________________________________________________________
'  ,  , ,      
For IMA = WING_LEFT_0 To WING_LEFT_3
imgImage(IMA).Tag = IMAGE_ENGAGED
Next IMA
For IMA = WING_RIGHT_0 To WING_RIGHT_3
imgImage(IMA).Tag = IMAGE_ENGAGED
Next IMA

' 
boolPotEngaged = False
'________________________________________________________________________________
' 
ShuffleCards
''________________________________________________________________________________
'   
AttachCards

'     
boolFirstAce = False

End Sub

Private Sub ShowAllCards()
' "" 
For intQ = 0 To COUNTCARDS
    ActCard(intQ).Visible = True
Next intQ

'    ActCard(0).Visible = True
'    ActCard(1).Visible = True
'    ActCard(2).Visible = True
'    ActCard(3).Visible = True
'    ActCard(4).Visible = True
'    ActCard(5).Visible = True
'    ActCard(6).Visible = True
'    ActCard(7).Visible = True
'    ActCard(8).Visible = True
'    ActCard(9).Visible = True
'    ActCard(10).Visible = True
'    ActCard(11).Visible = True
'    ActCard(12).Visible = True
'    ActCard(13).Visible = True
'    ActCard(14).Visible = True
'    ActCard(15).Visible = True
'    ActCard(16).Visible = True
'    ActCard(17).Visible = True
'    ActCard(18).Visible = True
'    ActCard(19).Visible = True
'    ActCard(20).Visible = True
'    ActCard(21).Visible = True
'    ActCard(22).Visible = True
'    ActCard(23).Visible = True
'    ActCard(24).Visible = True
'    ActCard(25).Visible = True
'    ActCard(26).Visible = True
'    ActCard(27).Visible = True
'    ActCard(28).Visible = True
'    ActCard(29).Visible = True
'    ActCard(30).Visible = True
'    ActCard(31).Visible = True
'    ActCard(32).Visible = True
'    ActCard(33).Visible = True
'    ActCard(34).Visible = True
'    ActCard(35).Visible = True
'    ActCard(36).Visible = True
'    ActCard(37).Visible = True
'    ActCard(38).Visible = True
'    ActCard(39).Visible = True
'    ActCard(40).Visible = True
'    ActCard(41).Visible = True
'    ActCard(42).Visible = True
'    ActCard(43).Visible = True
'    ActCard(44).Visible = True
'    ActCard(45).Visible = True
'    ActCard(46).Visible = True
'    ActCard(47).Visible = True
'    ActCard(48).Visible = True
'    ActCard(49).Visible = True
'    ActCard(50).Visible = True
'    ActCard(51).Visible = True

End Sub
Private Sub HideAllCards()
' "" 

For intQ = 0 To COUNTCARDS
    ActCard(intQ).Visible = False
Next intQ

'    ActCard(0).Visible = False
'    ActCard(1).Visible = False
'    ActCard(2).Visible = False
'    ActCard(3).Visible = False
'    ActCard(4).Visible = False
'    ActCard(5).Visible = False
'    ActCard(6).Visible = False
'    ActCard(7).Visible = False
'    ActCard(8).Visible = False
'    ActCard(9).Visible = False
'    ActCard(10).Visible = False
'    ActCard(11).Visible = False
'    ActCard(12).Visible = False
'    ActCard(13).Visible = False
'    ActCard(14).Visible = False
'    ActCard(15).Visible = False
'    ActCard(16).Visible = False
'    ActCard(17).Visible = False
'    ActCard(18).Visible = False
'    ActCard(19).Visible = False
'    ActCard(20).Visible = False
'    ActCard(21).Visible = False
'    ActCard(22).Visible = False
'    ActCard(23).Visible = False
'    ActCard(24).Visible = False
'    ActCard(25).Visible = False
'    ActCard(26).Visible = False
'    ActCard(27).Visible = False
'    ActCard(28).Visible = False
'    ActCard(29).Visible = False
'    ActCard(30).Visible = False
'    ActCard(31).Visible = False
'    ActCard(32).Visible = False
'    ActCard(33).Visible = False
'    ActCard(34).Visible = False
'    ActCard(35).Visible = False
'    ActCard(36).Visible = False
'    ActCard(37).Visible = False
'    ActCard(38).Visible = False
'    ActCard(39).Visible = False
'    ActCard(40).Visible = False
'    ActCard(41).Visible = False
'    ActCard(42).Visible = False
'    ActCard(43).Visible = False
'    ActCard(44).Visible = False
'    ActCard(45).Visible = False
'    ActCard(46).Visible = False
'    ActCard(47).Visible = False
'    ActCard(48).Visible = False
'    ActCard(49).Visible = False
'    ActCard(50).Visible = False
'    ActCard(51).Visible = False
End Sub

Private Sub Form_Load()
' 
' 
Me.MousePointer = vbHourglass
frmSplash.MousePointer = vbHourglass
'
'Show
' 
frmSplash.Show

DoEvents
'' 
InitGame
' 
Unload frmSplash
' 
Me.MousePointer = vbDefault

End Sub

Public Sub Deal()
'On Error Resume Next
'  

For intQ = 0 To COUNTCARDS

With ActCard(intQ)
    ' 
    If .CardFace = ecfAce Then
        ' - ""
        .State = esStopped
    End If
    
        '    
        .Move CardWing(.Col), CardRow(.Row)

End With

Next intQ

End Sub

Private Sub Form_Resize()
'   

Cls

'      
If Me.WindowState = vbNormal Then
    '  
    If Me.Width <= ActCard(0).ScaleWidth * 10 * Screen.TwipsPerPixelX Then
        Me.Width = ActCard(0).ScaleWidth * 10 * Screen.TwipsPerPixelX
    End If
    
    If Me.Height <= ActCard(0).Height * 5 * Screen.TwipsPerPixelY Then
        Me.Height = ActCard(0).Height * 5 * Screen.TwipsPerPixelY
    End If

End If

' ,     
ResizeForm

End Sub

Private Sub Form_Unload(Cancel As Integer)

Dim Msg, Response   ' Declare variables.

Msg = "?"

Response = MsgBox(Msg, vbQuestion + vbYesNo)

Select Case Response
    Case vbNo   ' Don't allow close.
        Cancel = -1
    Case vbYes
        Cancel = 0
End Select

'MsgBox Msg, vbOKOnly, "Exit"   ' Display message.

End Sub

Private Sub mnuAbout_Click()

frmAbout.Show 1

End Sub


Private Sub mnuExit_Click()
' - 
Unload Me

End Sub

Public Sub InitForm()
' 
On Error Resume Next

For intQ = 1 To 14

    '  "" 
    '(  resize  )
    Load imgImage(intQ)

Next intQ

End Sub

Private Sub ResizeForm()
'    -   
Dim CardWidth, CardWidth2, CardCol2

'   -   
If Me.WindowState = vbMinimized Then Exit Sub

' -  
CardWidth = ActCard(0).Width * Screen.TwipsPerPixelX

'  
'
For intQ = 0 To 4
    CardRow(intQ) = ((ActCard(0).Height + 6) * intQ) + 10
Next intQ

'
CardWing(CENTER) = (Me.Width - CardWidth) \ 2

' 
CardWidth = CardWidth - CARDSHIFT
CardWidth2 = CardWidth + CARDSHIFT * 2

'
For intQ = 0 To 9
    Select Case intQ
        Case 0
            CardWing(0) = (CardWing(CENTER) - CardWidth2) _
                            / Screen.TwipsPerPixelX
        Case 1
            CardWing(1) = (CardWing(CENTER) + CardWidth2) _
                            / Screen.TwipsPerPixelX
        Case 2
            CardWing(2) = (CardWing(CENTER) - (CardWidth2 + CardWidth)) _
                            / Screen.TwipsPerPixelX
        Case 3
            CardWing(3) = (CardWing(CENTER) + (CardWidth2 + CardWidth)) _
                            / Screen.TwipsPerPixelX
        Case 4
            CardWing(4) = (CardWing(CENTER) - (CardWidth2 + CardWidth * 2)) _
                            / Screen.TwipsPerPixelX
        Case 5
            CardWing(5) = (CardWing(CENTER) + (CardWidth2 + CardWidth * 2)) _
                            / Screen.TwipsPerPixelX
        Case 6
            CardWing(6) = (CardWing(CENTER) - (CardWidth2 + CardWidth * 3)) _
                            / Screen.TwipsPerPixelX
        Case 7
            CardWing(7) = (CardWing(CENTER) + (CardWidth2 + CardWidth * 3)) _
                            / Screen.TwipsPerPixelX
        Case 8
            CardWing(8) = (CardWing(CENTER) - (CardWidth2 + CardWidth * 4)) _
                            / Screen.TwipsPerPixelX
        Case 9
            CardWing(9) = (CardWing(CENTER) + (CardWidth2 + CardWidth * 4)) _
                            / Screen.TwipsPerPixelX
    End Select
Next intQ

CardWing(CENTER) = CardWing(CENTER) / Screen.TwipsPerPixelX

DoEvents

'  "" 
ResizeImages

' ""
ActCard(POT).Visible = False

' ""
ActCard(POT).Move CardWing(CENTER), CardRow(4)

' ""
ActCard(POT).Visible = True

'  
HideAllCards

'   
Deal

'  
ShowAllCards

End Sub

Private Sub AttachCards()
'    

Dim R, C ' ,     

intW = 0 ' 

R = 0
C = 0

'  
For intQ = 0 To COUNTCARDS

With ActCard(intQ)

    '   - ,
    If .CardFace = ecfAce Then
        '     
        .Row = intW
        .Col = CENTER
        .ZOrd = 0
        ' 
        intW = intW + 1
    ' -     
    Else
        '    
        .Row = R
        .Col = C
        .ZOrd = 0
       
        '   
        .ZOrder
        
        '   
        If R < 4 And C > 7 Then
            .State = esFree
        ElseIf R = 4 And C > 5 Then
            .State = esMoveable
        Else
            .State = esEngaged
        End If
        
        ' 
        R = R + 1
            '      -  
            If R = 4 And C = 8 Then
                R = 0
                C = 9
            End If
            If R = 5 Then
                R = 0
                C = C + 1
            End If
    End If
    
End With
    
Next intQ

End Sub

Private Sub ShuffleCards()
' 

'  
For intQ = 0 To COUNTCARDS
    MedAr(intQ) = intQ
Next intQ

' 
ShuffleArray MedAr() 'CardPack()

For intQ = 0 To COUNTCARDS
    '  
    ActCard(intQ).CardFace = (MedAr(intQ) \ 4) * 4
    '  
    ActCard(intQ).CardSuit = MedAr(intQ) - (MedAr(intQ) \ 4) * 4
Next intQ

End Sub

Private Sub Push(intItem As Integer, intFirstRow As Integer, intFirstWing As Integer, _
                                                                intFirstZ As Integer, esState As EState, _
                                                                intEndRow As Integer, intEndCol As Integer, _
                                                                intEndZOrd As Integer, boolExplFrPot As Boolean, _
                                                                boolExplDir As Boolean)
'     
' -     ,
'  ,   ,
'   ,
',    
',  ,      

'  
intStackCounter = intStackCounter + 1

ReDim Preserve Stack(intStackCounter)
'   
With Stack(intStackCounter)

    .FirstRow = intFirstRow
    .FirstWing = intFirstWing
    .FirstZOrd = intFirstZ
    .FirstState = esState
    .Item = intItem
    .ExplicitFreePot = boolExplFrPot
    .ExplicitDirection = boolExplDir
    .EndCol = intEndCol
    .EndRow = intEndRow
    .EndZOrd = intEndZOrd
    
End With

End Sub

Private Function Pop(boolEmpty As Boolean) As StackCell

'   -  
If intStackCounter = 0 Then
    boolEmpty = True
    ' 
    Exit Function
End If

' -  
boolEmpty = False


ReDim Preserve Stack(intStackCounter)

Pop = Stack(intStackCounter)

'  
intStackCounter = intStackCounter - 1

End Function

Private Function PlacedCard(intIndex As Integer, boolFrBtm As Boolean) As Boolean
'  TRUE,    ,
' FALSE,     

'    
' -    , , ,     

Dim crdX, crdY, crdR, crdB
Dim intComparition As Integer '   ,  1 -    
                                                ' ,  -1 -      ,
                                                '  0 -   
                                                
Dim boolEngWing As Boolean ', ,  ,  , .
'_________________________________________________________________________________
'   
With ActCard(intIndex)
crdX = .Left '
crdY = .Top '
crdR = .Left + .Width '
crdB = .Top + .Height ' 
End With
'_________________________________________________________________________________
'    
For intQ = 0 To COUNTCARDS
With ActCard(intQ)
    
'          (  )
If ActCard(intIndex).CardSuit = .CardSuit Then
    '  
    If (crdY >= .Top And crdY <= .Top + .Height) Or (crdB <= .Top + .Height And crdB >= .Top) Then
        '  
        If (crdX >= .Left And crdX <= .Left + .Width) Or (crdR <= .Left + .Width And crdR >= .Left) Then
            '     
            If .State = esFree Or .State = esStopped Then
                '  
                intComparition = CompareCards(ActCard(intIndex).CardFace, .CardFace)
                '   -   
                If intComparition <> 0 Then
                '_________________________________________________________________________________
                    If .CardFace = ecfAce Then
                        '  ,   -    , 
                        If boolFirstAce = False Then
                            ' . 
                            If intComparition = 1 Then
                                boolFirstAce = True
                                boolDirection = True
                                '     ,  ,
                                '      ,
                                '       
                                If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                                    And boolBottomEmpty = False Then
                                    CardPos intQ, True, True, intIndex
                                Else
                                    CardPos intQ, False, True, intIndex
                                End If
                                ' 
                                PlacedCard = True
                                '
                                Exit Function
                            ElseIf intComparition = -1 Then
                                boolFirstAce = True
                                boolDirection = False
                                '     ,  ,
                                '      ,
                                '       
                                If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                                    And boolBottomEmpty = False Then
                                    CardPos intQ, True, True, intIndex
                                Else
                                    CardPos intQ, False, True, intIndex
                                End If
                                ' 
                                PlacedCard = True
                                '
                                Exit Function
                            End If
                        '    ,       
                        '    ,       
                        Else 'If boolFirstAce = True Then
                            If (boolDirection = True And intComparition = 1) _
                            Or (boolDirection = False And intComparition = -1) Then
                            '  
                            '     ,  ,
                            '      ,
                            '       
                            If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                                And boolBottomEmpty = False Then
                                CardPos intQ, True, True, intIndex
                            Else
                                CardPos intQ, False, True, intIndex
                            End If
                            ' 
                            PlacedCard = True
                            '
                            Exit Function
                            End If
                        End If
                    '_________________________________________________________________________________
                    ElseIf .CardFace > ecfAce Then
                        '    ,      
                        '  
                        '     ,  ,
                        '      ,
                        '       
                        If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                            And boolBottomEmpty = False Then
                            CardPos intQ, True, True, intIndex
                        Else
                            CardPos intQ, False, True, intIndex
                        End If
                        ' 
                        PlacedCard = True
                        '
                        Exit Function
                    End If
                '_________________________________________________________________________________
                End If
            End If
        End If
    End If
End If
End With
Next intQ
''_________________________________________________________________________________
'     ?
With ActCard(POT)
'       
If (crdY >= .Top And crdY <= .Top + .Height) Or (crdB <= .Top + .Height And crdB >= .Top) Then
    '  
    If (crdX >= .Left And crdX <= .Left + .Width) Or (crdR <= .Left + .Width And crdR >= .Left) Then
        '   
        If boolPotEngaged = False Then
            '  
            '     ,  ,
            '      ,
            '       
            If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                And boolBottomEmpty = False Then
                CardPos intQ, True, True, intIndex
            Else
                CardPos intQ, False, True, intIndex
            End If
            ' 
            boolPotEngaged = True
            ',         ?
            If boolBottomEmpty = True Then
                '  -      (    )
                ActCard(intIndex).State = esMoveable
            Else
                ActCard(intIndex).State = esEngaged
            End If
            ' 
            PlacedCard = True
            '
            Exit Function
        End If
    End If
End If
End With
''_________________________________________________________________________________
''      ?
''  
For IMA = WING_LEFT_0 To WING_LEFT_3
With imgImage(IMA)
'      
If (crdY >= .Top And crdY <= .Top + .Height) Or (crdB <= .Top + .Height And crdB >= .Top) Then
    '  
    If (crdX >= .Left And crdX <= .Left + .Width) Or (crdR <= .Left + .Width And crdR >= .Left) Then
        '   
        If .Tag = IMAGE_FREE Then
            '    
            '     ,  ,
            '      ,
            '       
            If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                And boolBottomEmpty = False Then
                CardPosEmptyRow intIndex, True, IMA
            Else
                CardPosEmptyRow intIndex, False, IMA
           End If
            ' 
            PlacedCard = True
            '
            Exit Function
        End If
    End If
End If
End With
Next IMA
'
''  
For IMA = WING_RIGHT_0 To WING_RIGHT_3
With imgImage(IMA)
'      
If (crdY >= .Top And crdY <= .Top + .Height) Or (crdB <= .Top + .Height And crdB >= .Top) Then
    '  
    If (crdX >= .Left And crdX <= .Left + .Width) Or (crdR <= .Left + .Width And crdR >= .Left) Then
        '   
        If .Tag = IMAGE_FREE Then
            '    
            '     ,  ,
            '      ,
            '       
            If StartRow = 4 And (StartWing = 0 Or StartWing = 1) _
                                                                And boolBottomEmpty = False Then
                CardPosEmptyRow intIndex, True, IMA
            Else
                CardPosEmptyRow intIndex, False, IMA
           End If
            ' 
            PlacedCard = True
            '
            Exit Function
        End If
    End If
End If
End With
Next IMA
''_________________________________________________________________________________
'   -    ,  
ActCard(intIndex).Move CardWing(StartWing), CardRow(StartRow)

StartRow = -1
StartState = -1
StartWing = -2
StartZOrd = -1

'  
PlacedCard = False

End Function

Private Sub MoveUndo()
'   

Dim eccUndo As StackCell
Dim boolNoSuccess As Boolean
Dim boolFB As Boolean
Dim intQQ As Integer

boolFB = False

'   
eccUndo = Pop(boolNoSuccess)

'   -   
'
If boolNoSuccess = True Then Exit Sub

With ActCard(eccUndo.Item)

'    
StartRow = eccUndo.EndRow
StartWing = eccUndo.EndCol
StartZOrd = eccUndo.EndZOrd
StartState = .State

'    
.Move CardWing(eccUndo.FirstWing), CardRow(eccUndo.FirstRow)
'
.ZOrder
'  
.State = eccUndo.FirstState

ReturnMove

'  ?
'    ,    ,    
'  
If eccUndo.FirstWing > 1 Then
        For intQ = 0 To COUNTCARDS
                If ActCard(intQ).Row = eccUndo.FirstRow Then
                        If ActCard(intQ).Col = eccUndo.FirstWing - 2 Then
                                ActCard(intQ).State = esEngaged
                                Exit For
                        End If
                End If
        Next intQ
End If

'    ,   , , ,   
'    ""
If eccUndo.FirstWing = 0 Then
    imgImage(eccUndo.FirstRow + 5).Tag = IMAGE_ENGAGED
ElseIf eccUndo.FirstWing = 1 Then
    imgImage(eccUndo.FirstRow + 10).Tag = IMAGE_ENGAGED
End If

ChangeFreeCard

'    
.Row = eccUndo.FirstRow
.Col = eccUndo.FirstWing
.ZOrd = eccUndo.FirstZOrd

End With

'        ,
'   
If eccUndo.ExplicitDirection = True Then
        boolFirstAce = False
End If
        
'      ,  
If eccUndo.ExplicitFreePot = True Then
    boolBottomEmpty = False
        ',     
        If boolPotEngaged = True Then
            For intQQ = 0 To COUNTCARDS
            With ActCard(intQQ)
                    If .Row = CENTER_POT Then
                            If .Col = CENTER Then
                                '   
                                .State = esStopped
                                Exit For
                            End If
                    End If
            End With
            Next intQQ
        End If
End If
        
End Sub

Private Sub mnuGameHelp_Click()

Dim WW

WW = WinHelp(Me.hWnd, App.Path & "\Chez'd'Oevre.hlp", 3, 0)

End Sub


Private Sub mnuNew_Click()

HideAllCards

InitGame

ShowAllCards

End Sub

Private Sub mnuUndo_Click()

MoveUndo

End Sub




Private Sub ChangeFreeCard()
'  ,  
' -      

Dim intQQ As Integer

'   
If StartZOrd = 0 Then
    If StartWing > 1 Then
            ' 
            For intW = 0 To COUNTCARDS
            With ActCard(intW)
                '     ,   
                If .Row = StartRow Then
                        '    
                        If .Col = StartWing - 2 Then
                                ' 
                                If StartRow < 4 Then
                                    .State = esFree
                                Else
                                    .State = esMoveable
                                End If
                        Exit For
                        End If
                End If
            End With
            Next intW
    '  ,    -  
    '  -    ,     
    ElseIf StartWing < 2 Then
            '       (   )
            If StartRow < 4 Then
                    '      -    ,
                    If (StartWing \ 2) * 2 = StartWing Then
                        imgImage(StartRow + 5).Tag = IMAGE_FREE
                    ' -    
                    Else
                        imgImage(StartRow + 10).Tag = IMAGE_FREE
                    End If
            ',      ,   (     ,
            '      )
            ElseIf StartRow = 4 And StartWing > CENTER Then
            boolBottomEmpty = True
                    ',     
                    If boolPotEngaged = True Then
                            For intQQ = 0 To COUNTCARDS
                            With ActCard(intQQ)
                                    If .Row = CENTER_POT Then
                                            If .Col = CENTER Then
                                                '   
                                                .State = esMoveable
                                                Exit For
                                            End If
                                    End If
                            End With
                            Next intQQ
                    End If
            ',     
            ElseIf StartRow = 4 And StartWing = CENTER Then
                boolPotEngaged = False
            End If
    End If
'___________________________________________________________________________________
'     
Else
    ' 
    For intW = 0 To COUNTCARDS
    With ActCard(intW)
        '     ,   
        If .Row = StartRow Then
            '     
            If .Col = StartWing Then
                '    
                If .ZOrd = StartZOrd - 1 Then
                    ' 
                    If StartWing > CENTER Then
                            If StartRow < 4 Then
                                .State = esFree
                            Else
                                .State = esMoveable
                            End If
                    Else
                            .State = esStopped
                    End If
                Exit For
                End If
            End If
        End If
    End With
    Next intW
End If

End Sub
Private Sub InitGame()
' 

InitForm

' 
intStackCounter = 0

'   ,     
imgImage(BOTTOM_LEFT).Tag = IMAGE_ENGAGED
imgImage(BOTTOM_RIGHT).Tag = IMAGE_ENGAGED

InitCards

Deal

End Sub

Private Sub ResizeImages()
' 

For IMA = CENTER_0 To CENTER_POT
With imgImage(IMA)
    ' 
    .Visible = False

    .Height = ActCard(0).Height + 4
    .Width = ActCard(0).Width + 4
    
    .Top = CardRow(IMA) - 2
    .Left = CardWing(CENTER) - 2
    
    .Visible = True
End With
Next IMA

For IMA = WING_LEFT_0 To WING_LEFT_3
With imgImage(IMA)
    ' 
    .Visible = False

    .Height = ActCard(0).Height + 4
    .Width = (CardWing(0) - CardWing(8)) + ActCard(0).Width + 4

    .Top = CardRow(IMA - 5) - 2
    .Left = CardWing(8) - 2

    .Visible = True
End With
Next IMA

With imgImage(BOTTOM_LEFT)
    .Visible = False

    .Height = ActCard(0).Height + 4
    .Width = (CardWing(0) - CardWing(6)) + ActCard(0).Width + 4

    .Top = CardRow(IMA - 5) - 2
    .Left = CardWing(6) - 2

    .Visible = True
End With

For IMA = WING_RIGHT_0 To WING_RIGHT_3
With imgImage(IMA)
    ' 
    .Visible = False

    .Height = ActCard(0).Height + 4
    .Width = (CardWing(9) - CardWing(1)) + ActCard(0).Width

    .Top = CardRow(IMA - 10) - 2
    .Left = CardWing(1)

    .Visible = True
End With
Next IMA

With imgImage(BOTTOM_RIGHT)
    .Visible = False

    .Height = ActCard(0).Height + 4
    .Width = (CardWing(7) - CardWing(1)) + ActCard(0).Width

    .Top = CardRow(IMA - 10) - 2
    .Left = CardWing(1)

    .Visible = True
End With
End Sub

Private Sub CardPosEmptyRow(intIndex As Integer, pExplFrPot As Boolean, IMA As IMAGES)
'     
' -    

Dim W As Integer, R As Integer

'  - 
imgImage(IMA).Tag = IMAGE_ENGAGED

'  
If IMA > CENTER_POT And IMA < BOTTOM_LEFT Then
    '     
    W = 0
    R = IMA - 5
Else
    ' -   
    W = 1
    R = IMA - 10
End If

With ActCard(intIndex)
    '  
    .Move CardWing(W), CardRow(R)
    
    '  - 
    .State = esMoveable
    
    '   
    '   
    Push intIndex, StartRow, StartWing, StartZOrd, StartState, R, W, 0, pExplFrPot, False ' boolED
    
    '  
    .Row = R
    .Col = W
    .ZOrd = 0
End With

End Sub

Private Function CheckEmptyPack() As Boolean
',    
'  -  TRUE

For intQ = 0 To COUNTCARDS
    '     
    If ActCard(intQ).Col > CENTER Then
        '       -   
        CheckEmptyPack = False
        Exit Function
    End If
    '   -   
    If ActCard(intQ).Row = 4 Then
        '    -   
        CheckEmptyPack = False
        Exit Function
    End If
Next intQ

'   -    
CheckEmptyPack = True

End Function

Private Sub Greetings()
' 

MsgBox "!"

End Sub

Private Sub CardPos(pTag As Integer, pExplFrPot As Boolean, pExplDir As Boolean, pIndex As Integer)
'   
' -  -,  - 
'  ,     
Dim pCol As Integer, pRow As Integer, pZOrd As Integer, pState As EState

'  
With ActCard(pTag)
    pCol = .Col
    pRow = .Row
    pZOrd = .ZOrd + 1
    pState = .State
    .State = esEngaged '"" -,      
End With

With ActCard(pIndex)

' 
.Move CardWing(pCol), CardRow(pRow)

' 
.State = pState

' 
.ZOrder

'   
Push pIndex, StartRow, StartWing, StartZOrd, StartState, pRow, pCol, pZOrd, pExplFrPot, pExplDir

'  
.Row = pRow
.Col = pCol
.ZOrd = pZOrd

End With
End Sub

Private Sub ReturnMove()
'   
       
'     
If StartWing = -1 And StartRow = 4 Then
        ' 
        boolPotEngaged = False

'           
ElseIf StartZOrd > 0 And StartWing > CENTER Then
        '    
        For intQ = 0 To COUNTCARDS
        With ActCard(intQ)
                '      
                If .Row = StartRow Then
                        '   
                        If .Col = StartWing Then
                                '  
                                If .ZOrd = StartZOrd - 1 Then
                                        '  
                                        .ZOrder
                                        '  
                                        .State = esFree
                                        Exit Sub
                                End If
                        End If
                End If
        End With
        Next intQ
'          
ElseIf StartZOrd > 0 And StartWing = CENTER Then
        '    
        For intQ = 0 To COUNTCARDS
        With ActCard(intQ)
                '      
                If .Row = StartRow Then
                        '   
                        If .Col = StartWing Then
                                '  
                                If .ZOrd = StartZOrd - 1 Then
                                        '  
                                        .ZOrder
                                        '  
                                        .State = esStopped
                                        Exit Sub
                                End If
                        End If
                End If
        End With
        Next intQ
' -           
ElseIf StartZOrd = 0 And StartWing > 1 Then '
        For intQ = 0 To COUNTCARDS
        With ActCard(intQ)
                '  ,   
                If .Col = StartWing - 2 Then
                        '    
                        If .Row = StartRow Then
                                '  
                                .ZOrder
                                '  
                                .State = esFree
                                Exit Sub
                        End If
                End If
        End With
        Next intQ
ElseIf StartZOrd = 0 And StartWing < 2 Then
        '     
        If StartRow < 4 Then
                '      -    ,
                If (StartWing \ 2) * 2 = StartWing Then
                        imgImage(StartRow).Tag = IMAGE_FREE
                ' -    
                Else
                        imgImage(StartRow + 5).Tag = IMAGE_FREE
                End If
        End If
End If

End Sub
